import { createContext, useContext } from "react";

var initContext = function initContext(store) {
  var ctx;

  var getCtx = function getCtx() {
    if (ctx) return ctx;
    ctx = /*#__PURE__*/createContext(store);
    return ctx;
  };

  return getCtx;
};

export var NO_PROVIDER = {};
export function genModelCtx(displayName) {
  var getCtx = initContext(NO_PROVIDER);
  var Context = getCtx();
  Context.displayName = displayName;

  var useCtx = function useCtx() {
    var ctx = useContext(Context);
    if (ctx === NO_PROVIDER) throw new Error("".concat(Context.displayName, "\u672A\u5728\u7EC4\u4EF6\u5916\u5C42\u5305\u88F9Provider\uFF0C\u65E0\u6CD5\u901A\u8FC7\u4E0A\u4E0B\u6587\u8BBF\u95EE"));
    return ctx;
  };

  return {
    useCtx: useCtx,
    Context: Context
  };
}