/**
 * 根据传入的store和handler对象，自动类型推导。
 * @param store
 * @param actionHandler
 * @returns
 */
export declare function useReducerEnhance<Store, Action>(store: Store, actionHandler: {
    [type in keyof Action]: (store: Store, payload?: any) => Store;
}): {
    state: Store;
    dispatch: import("react").Dispatch<{
        type: keyof Action;
        payload?: any;
    }>;
    dispatchAction: { [type in keyof Action]: (payload?: any) => void; };
};
